SystemOrganization addCategory: #'OB-Web-Core'!
SystemOrganization addCategory: #'OB-Web-Widgets'!

HttpService subclass: #OBHttpService
	instanceVariableNames: 'windows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Core'!

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:06'!
createLauncher
	| launcher |
	launcher _ OBWebLauncher new.
	windows add: launcher.
	^ launcher initialResponse! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:00'!
createWindowFor: aBrowser
	| window |
	window _ OBWebWindow model: aBrowser.
	windows add: window.
	^ window! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:03'!
initialize
	super initialize.
	windows _ Set new! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:02'!
notFound: aRequest
	^ HttpResponse 
		status: #notFound
		contents: aRequest url, ' was not found on this server'! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:15'!
processGet: aRequest
	
	aRequest url = '/' ifTrue: [^ self createLauncher].
	^ self 
		targetForRequest: aRequest
		ifPresent: [:target | target html]! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/21/2006 00:16'!
processHttpRequest: aRequest
	| response |
	response _ [(aRequest method = 'GET')
		ifTrue: [self processGet: aRequest]
		ifFalse: [self processPost: aRequest]]
			on: OBBrowseRequest
			do: [:req | req resume: (self createWindowFor: req browser)].
	^ response! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/21/2006 00:13'!
processPost: aRequest
	| message object |
	object _ Json readFrom: aRequest rawPostFields readStream.
	message _ Message
				selector: (object at: 'selector') asSymbol
				arguments: (object at: 'arguments').
	^ self 
		targetForRequest: aRequest
		ifPresent: [:target | Json render: (target processMessage: message)]! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 23:37'!
targetForRequest: aRequest ifPresent: aBlock
	| id target val |
	id _ aRequest url allButFirst.
	target _ windows
				detect: [:ea | id = ea identifier]
				ifNone: [^ self notFound: aRequest].
	val _ aBlock value: target.
	^ HttpResponse fromString: val! !

!HttpRequest methodsFor: '*ob-web-accessing' stamp: 'cwp 10/19/2006 23:38'!
postData
	| rawPostFields |
	rawPostFields _ self rawPostFields.
	^ rawPostFields isEmpty
		ifTrue: [stream next: self contentLength]
		ifFalse: [rawPostFields]! !

Object subclass: #OBWebBuilder
	instanceVariableNames: 'current'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Core'!

!OBWebBuilder class methodsFor: 'as yet unclassified' stamp: 'cwp 10/23/2006 14:55'!
new
	^ self basicNew initialize! !

!OBWebBuilder methodsFor: 'as yet unclassified' stamp: 'cwp 10/23/2006 14:56'!
addChild: anObject
	current _ anObject! !

!OBWebBuilder methodsFor: 'as yet unclassified' stamp: 'cwp 10/23/2006 14:51'!
browser: aBrowser with: aBlock
	self 
		current: (OBWebWindow model: aBrowser)
		do: aBlock.
! !

!OBWebBuilder methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 10:13'!
column: aColumn with: aBlock
	self
		current: (OBWebPane model: aColumn)
		do: [self
				current: (OBWebList model: aColumn)
				do: aBlock]! !

!OBWebBuilder methodsFor: 'as yet unclassified' stamp: 'cwp 10/23/2006 14:51'!
columnPanel: aColumnPanel with: aBlock 
	self
		current: (OBWebScroller model: aColumnPanel)
		do: aBlock! !

!OBWebBuilder methodsFor: 'as yet unclassified' stamp: 'cwp 10/23/2006 14:57'!
current: aWidget do: aBlock
	| saved |
	current addChild: aWidget.
	saved _ current.
	current _ aWidget.
	aBlock ensure: [current _ saved]! !

!OBWebBuilder methodsFor: 'as yet unclassified' stamp: 'cwp 10/23/2006 14:52'!
definitionPanel: aPanel with: aBlock
	self 
		current: (OBWebText model: aPanel)
		do: aBlock! !

!OBWebBuilder methodsFor: 'as yet unclassified' stamp: 'cwp 10/23/2006 14:56'!
initialize
	current _ self
		! !

!OBWebBuilder methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 10:32'!
modalFilter: aFilter with: aBlock
	self
		current: (OBWebButtonBar model: aFilter)
		do: aBlock! !

!OBWebBuilder methodsFor: 'as yet unclassified' stamp: 'cwp 10/23/2006 14:56'!
root
	^ current! !

Object subclass: #OBWebLauncher
	instanceVariableNames: 'id queue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Core'!

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/19/2006 23:53'!
allowedSelectors
	^ #(openBrowser)! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 23:27'!
flushQueue
	| tmp |
	tmp _ queue asArray.
	queue _ OrderedCollection new.
	^ tmp! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 22:40'!
html
	^ '<html>
<head>
	<title>launcher</title>
	<script src="http://localhost/ob/link.js"></script>
	<script src="http://localhost/ob/launcher.js"></script>
</head>
<body onload="initialize()">
	<div id="id1">
		<a href="javascript:launcher.openBrowser()">open browser</a>
	</div>
	<script>
		function initialize()
		{
			link = new Link(window.location);
			launcher = new Launcher("id1");
		}
	</script>
</body>
</html>
'! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:19'!
id
	^ id! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:19'!
identifier
	^ id asString! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:16'!
initialResponse
	^ HttpResponse fromUrl: self path! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 22:16'!
initialize
	id _ UUID new.
	queue _ OrderedCollection new.! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/21/2006 01:12'!
openBrowser
	| window |
	window _ OBSystemBrowser open.
	self queueMessage: (JsonObject new
							receiver: 'id1';
							selector: 'openWindow';
							arguments: {window path};
							yourself)! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:16'!
path
	^ id asString copyWithFirst: $/! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 23:29'!
processMessage: aMessage
	(self allowedSelectors includes: aMessage selector)
		ifTrue: [aMessage sendTo: self]
		ifFalse: [self webDoesNotUnderstand: aMessage].
	^ self flushQueue! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 22:17'!
queueMessage: aMessageSend
	queue add: aMessageSend! !

Object subclass: #OBWebWidget
	instanceVariableNames: 'id model children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

OBWebWidget subclass: #OBWebButtonBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

OBWebWidget subclass: #OBWebList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

OBWebWidget subclass: #OBWebPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

OBWebWidget subclass: #OBWebScroller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

OBWebWidget subclass: #OBWebText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

!OBWebText methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 15:15'!
htmlClass
	^ 'vertical'! !

!OBWebText methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 15:31'!
htmlStyle
	^ 'top: 40%; height: 60%'! !

!OBWebWidget class methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 14:44'!
id: aWebIdentifier model: anObject
	^ (self basicNew initializeWithId: aWebIdentifier)
		model: anObject;
		yourself! !

!OBWebWidget class methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2006 02:10'!
model: aBrowser
	^ self new model: aBrowser! !

!OBWebWidget class methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2006 02:10'!
new
	^ self basicNew initialize! !

!OBWebWidget methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2006 02:09'!
addChild: aWidget
	children add: aWidget! !

!OBWebWidget methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2006 01:50'!
children
	^ children! !

!OBWebWidget methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 14:52'!
html
	^ String streamContents: [:s | self htmlOn: s]! !

!OBWebWidget methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 15:31'!
htmlStyle
	^ nil! !

!OBWebWidget methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 15:31'!
htmlTagOn: aStream
	aStream 
		nextPutAll: '<div id="';
		print: id;
		nextPutAll: '" class="';
		nextPutAll: self htmlClass;
		nextPut: $".
	self htmlStyle ifNotNilDo: 
		[:style | aStream
					nextPutAll: ' style="';
					nextPutAll: style;
					nextPut: $"].
	aStream nextPut: $>.
	children do: [:ea | ea htmlTagOn: aStream].
	aStream nextPutAll: '</div>'! !

!OBWebWidget methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2006 01:49'!
identifier
	^ id asString! !

!OBWebWidget methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 14:31'!
initialize
	self initializeWithId: (OBWebIdentifier new)! !

!OBWebWidget methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 14:30'!
initializeWithId: aWebIdentifier
	id _ aWebIdentifier.
	children _ OrderedCollection new.! !

!OBWebWidget methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2006 01:49'!
model
	^ model! !

!OBWebWidget methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2006 01:49'!
model: anObject
	model _ anObject! !

!OBWebWidget methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 15:21'!
style
	^ nil! !

OBWebWidget subclass: #OBWebWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

!OBWebWindow methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 15:04'!
htmlClass
	^ 'root'! !

!OBWebWindow methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 14:55'!
htmlOn: aStream
	aStream nextPutAll: '<html><head><title>browser</title><script src="link.js"></script><script src="widgets.js"></script><link rel="stylesheet" href="browser.css" type="text/css" /></head><body>'.
		self htmlTagOn: aStream.
	aStream 
		nextPutAll: '<script>link = new Link(window.location);</script>';
		nextPutAll: '</body></html>'
! !

!OBWebWindow methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:32'!
path
	^ self identifier copyWithFirst: $/! !

LargePositiveInteger variableByteSubclass: #OBWebIdentifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

!OBWebIdentifier class methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 11:23'!
defaultSize
	^ 16! !

!OBWebIdentifier class methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 11:22'!
new
	^ self new: self defaultSize! !

!OBWebIdentifier class methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 11:22'!
random: aRandom
	^ (self basicNew: self defaultSize) initializeWithRandom: aRandom! !

!OBWebIdentifier methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 11:11'!
initialize
	self initializeWithRandom: Random new! !

!OBWebIdentifier methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 11:15'!
initializeWithRandom: aRandom
	1 to: self size do: [:i | self at: i put: (aRandom nextInt: 255)]! !

!OBWebIdentifier methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 11:42'!
printOn: aStream
	
	| base digits current i letters quo |
	base _ 36.
	digits _ '0123456789abcdefghijklmnopqrstuvwxyz'.
	current _ self.
	i _ self digitLength * 8.
	letters _ String new: i.
	[current < base] whileFalse: 
		[quo _ current quo: base.
		letters at: i put: (digits at: (current - (quo * base)) + 1).
		i _ i - 1.
		current _ quo].
	letters at: i put: (digits at: current + 1).
	aStream nextPutAll: (letters copyFrom: i to: letters size)
	
! !
